com.tibco.bpm.service.connector

## Class OrgModelService

- java.lang.Object
- - com.tibco.bpm.service.connector.OrgModelService

- All Implemented Interfaces:
    OrgModelService

      public class OrgModelService
      extends java.lang.Object
      implements OrgModelService

  Provides access to the organzation model structure, and the properties of the entities contained within it.

  COPYRIGHT: (C) 2007-2012 TIBCO Software Inc. All Rights Reserved.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.tibco.bpm.de.api.orgmodel.GetCalendarReferencesResponseDocument.GetCalendarReferencesResponse` | `getCalendarReferences(int aModelVersion, com.tibco.n2.common.organisation.api.OrganisationalEntityType.Enum aEntityType, java.lang.String aGuid)` Returns the Calendar references that identify the Base and Overlay Calendars to be applied for deadline calculations involving the given model-entity.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse` | `getOrgModel(int aModelVersion, boolean includeResourceCounts)` Requests the details of the entities that form the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse` | `getOrgModel(int aModelVersion, boolean includeResourceCounts, boolean includeCalendarAlias)` Requests the details of the entities that form the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse` | `getOrgModel(int aModelVersion, boolean includeResourceCounts, boolean includeCalendarAlias, boolean includeCandidateQueries, boolean includeExtPoints)` Requests the details of the entities that form the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse` | `getOrgModel(int aModelVersion, boolean aIncludeResourceCounts, boolean aIncludeCalendarAlias, boolean aIncludeCandidateQueries, boolean aIncludeExtPoints, boolean aIncludeCategories)` Requests the details of the entities that form the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelEntityResponseDocument.GetOrgModelEntityResponse` | `getOrgModelEntity(int aModelVersion, java.lang.String[] aGuids)` Requests the details of the entities identified by the given major version and their GUID.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelRootsResponseDocument.GetOrgModelRootsResponse` | `getOrgModelRoots(int aModelVersion)` Requests the details of the entities that form the root elements of the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.GetOrgModelRootsResponseDocument.GetOrgModelRootsResponse` | `getOrgModelRoots(int aModelVersion, boolean aIncludeCategories)` Requests the details of the entities that form the root elements of the organzation model identified by the given major version.
    `com.tibco.bpm.de.api.orgmodel.XmlPushDestinationList[]` | `getPushDestinations(com.tibco.n2.common.organisation.api.XmlModelEntityId[] parameterValues)` Retrieve the Push Destinations for the identified org-model entities (or resource).
    `com.tibco.bpm.de.api.base.XmlOrgModelVersionDetail[]` | `listOrgModelVersions()` This operation lists the available organization model major versions.
    `void` | `processDynamicOrg()` Requests that the processing of the Extension Points and Candidate Queries be performed as soon as possible.
    `void` | `setCalendarReferences(com.tibco.n2.common.organisation.api.XmlCalendarAssignment[] aAssignments)` Assign Calendar References to model entities.
    `void` | `setCandidateQueries(com.tibco.bpm.de.api.orgmodel.SetCandidateQueriesDocument.SetCandidateQueries.Remove aRemovals, com.tibco.bpm.de.api.base.XmlCandidateQueryAssignment[] aAssignments)` Sets, or updates, the Candidate Query assignments to identified org-model entities.
    `void` | `setExtensionPoints(com.tibco.bpm.de.api.base.XmlExtensionPointAssignment[] aSettings)` Sets, or updates, the configurations for the identified Organisation Model Extension Point entities.
    `void` | `setExtensionPoints(com.tibco.bpm.de.api.base.XmlExtensionPointRemoval[] aSettings)`
    `void` | `updatePushDestinations(int aModelVersion, com.tibco.n2.common.organisation.api.OrganisationalEntityType.Enum aEntityType, java.lang.String aGuid, com.tibco.bpm.de.api.base.XmlPushDestinationId[] aRemovals, com.tibco.bpm.de.api.base.XmlPushDestination[] aUpdates)` Updates the Push Destinations for the identified org-model entity (or resource).

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### listOrgModelVersions

          public com.tibco.bpm.de.api.base.XmlOrgModelVersionDetail[] listOrgModelVersions()
                                                                                    throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                           com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      This operation lists the available organization model major versions.

      For each major version, the organization model deployments that make up that version will be detailed - giving their full version number, name and date deployed.

      Specified by:
        `listOrgModelVersions` in interface `OrgModelService`
      Returns:
        a list of the available organization model major versions.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModelRoots

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelRootsResponseDocument.GetOrgModelRootsResponse getOrgModelRoots(int aModelVersion)
                                                                                                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                          com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the root elements of the organzation model identified by the given major version. These will include; Organisations, Groups, Locations, Capabilities, Privileges, Resource Attributes and Model Templates. Using these root entities, it will be possible for the client to navgate the entire org-model in a "drill-down" fashion.
      Specified by:
        `getOrgModelRoots` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
      Returns:
        the details of the root entities of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModelRoots

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelRootsResponseDocument.GetOrgModelRootsResponse getOrgModelRoots(int aModelVersion,
                                                                                                                          boolean aIncludeCategories)
                                                                                                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                          com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the root elements of the organzation model identified by the given major version. These will include; Organisations, Groups, Locations, Capabilities, Privileges, Resource Attributes and Model Templates. Using these root entities, it will be possible for the client to navgate the entire org-model in a "drill-down" fashion.
      Specified by:
        `getOrgModelRoots` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
        `aIncludeCategories` - Specifies whether the capabilities and privileges should be grouped in the nested categories in which they were deployed.
      Returns:
        the details of the root entities of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModelEntity

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelEntityResponseDocument.GetOrgModelEntityResponse getOrgModelEntity(int aModelVersion,
                                                                                                                             java.lang.String[] aGuids)
                                                                                                                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                             com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities identified by the given major version and their GUID. If the identified entity has associations with other entities (e.g. positions associated with an org-unit), the GUID of those entities will be included in the response. This allows details of those entities to be retrieved.
      Specified by:
        `getOrgModelEntity` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
      Returns:
        the details of the identified org-model entity.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModel

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse getOrgModel(int aModelVersion,
                                                                                                           boolean includeResourceCounts)
                                                                                                    throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                           com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the organzation model identified by the given major version. This is the same as calling `getOrgModel(false, false)`.
      Specified by:
        `getOrgModel` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
        `includeResourceCounts` - determines whether the number of resources assigned to groups, positions and capabilities should be included in the response. For performance reasons, the caller may choose not to include these.
      Returns:
        the details of the entities and structure of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModel

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse getOrgModel(int aModelVersion,
                                                                                                           boolean includeResourceCounts,
                                                                                                           boolean includeCalendarAlias)
                                                                                                    throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                           com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the organzation model identified by the given major version.
      Specified by:
        `getOrgModel` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
        `includeResourceCounts` - determines whether the number of resources assigned to groups, positions and capabilities should be included in the response. For performance reasons, the caller may choose not to include these.
        `includeCalendarAlias` - determines whether the calendar alias assigned to groups, positions, org-units and organizations should be included in the response. For performance reasons, the caller may choose not to include these.
      Returns:
        the details of the entities and structure of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModel

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse getOrgModel(int aModelVersion,
                                                                                                           boolean includeResourceCounts,
                                                                                                           boolean includeCalendarAlias,
                                                                                                           boolean includeCandidateQueries,
                                                                                                           boolean includeExtPoints)
                                                                                                    throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                           com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the organzation model identified by the given major version.
      Specified by:
        `getOrgModel` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
        `includeResourceCounts` - determines whether the number of resources assigned to groups, positions and capabilities should be included in the response. For performance reasons, the caller may choose not to include these.
        `includeCalendarAlias` - determines whether the calendar alias assigned to groups, positions, org-units and organizations should be included in the response. For performance reasons, the caller may choose not to include these.
        `includeCandidateQueries` - determines whether the Candidate Queries assigned to groups and positions, should be included in the response.
      Returns:
        the details of the entities and structure of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getOrgModel

          public com.tibco.bpm.de.api.orgmodel.GetOrgModelResponseDocument.GetOrgModelResponse getOrgModel(int aModelVersion,
                                                                                                           boolean aIncludeResourceCounts,
                                                                                                           boolean aIncludeCalendarAlias,
                                                                                                           boolean aIncludeCandidateQueries,
                                                                                                           boolean aIncludeExtPoints,
                                                                                                           boolean aIncludeCategories)
                                                                                                    throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                           com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests the details of the entities that form the organzation model identified by the given major version.
      Specified by:
        `getOrgModel` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - identifies the major organization model version to be returned.
        `aIncludeResourceCounts` - determines whether the number of resources assigned to groups, positions and capabilities should be included in the response. For performance reasons, the caller may choose not to include these.
        `aIncludeCalendarAlias` - determines whether the calendar alias assigned to groups, positions, org-units and organizations should be included in the response. For performance reasons, the caller may choose not to include these.
        `aIncludeCandidateQueries` - determines whether the Candidate Queries assigned to groups and positions, should be included in the response.
        `aIncludeCategories` - Specifies whether the capabilities and privileges should be grouped in the nested categories in which they were deployed.
      Returns:
        the details of the entities and structure of the identified org-model.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getCalendarReferences

          public com.tibco.bpm.de.api.orgmodel.GetCalendarReferencesResponseDocument.GetCalendarReferencesResponse getCalendarReferences(int aModelVersion,
                                                                                                                                         com.tibco.n2.common.organisation.api.OrganisationalEntityType.Enum aEntityType,
                                                                                                                                         java.lang.String aGuid)
                                                                                                                                  throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                                         com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Returns the Calendar references that identify the Base and Overlay Calendars to be applied for deadline calculations involving the given model-entity.
      Specified by:
        `getCalendarReferences` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - the major model version of the org-model entity whose Calendar references are to be returned.
        `aEntityType` - the type of org-model entity whose Calendar references are to be returned.
        `aGuid` - the GUID of the org-model entity whose Calendar references are to be returned.
      Returns:
        the base and/or overlay calendar references for the identified org-model entity.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### setCalendarReferences

          public void setCalendarReferences(com.tibco.n2.common.organisation.api.XmlCalendarAssignment[] aAssignments)
                                     throws com.tibco.n2.de.services.DirectoryEngineFault,
                                            com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Assign Calendar References to model entities. The assignments will overwrite any existing assignments to the same model entities.
      Specified by:
        `setCalendarReferences` in interface `OrgModelService`
      Parameters:
        `aAssignments` - identifies the model-entities whose calendar alias values are to be set, and the aliases to be set.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### updatePushDestinations

          public void updatePushDestinations(int aModelVersion,
                                             com.tibco.n2.common.organisation.api.OrganisationalEntityType.Enum aEntityType,
                                             java.lang.String aGuid,
                                             com.tibco.bpm.de.api.base.XmlPushDestinationId[] aRemovals,
                                             com.tibco.bpm.de.api.base.XmlPushDestination[] aUpdates)
                                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                                             com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Updates the Push Destinations for the identified org-model entity (or resource).
      Specified by:
        `updatePushDestinations` in interface `OrgModelService`
      Parameters:
        `aModelVersion` - the major org-model version in which the entity resides.
        `aEntityType` - the type of the org-model entity (group, position, resource, etc).
        `aGuid` - the unique identifier of the org-model entity (or resource).
        `aRemovals` - the IDs of those push destinations to be removed from the identified entity. If `null`, no push destinations are removed.
        `aUpdates` - the push destinations to be create, or updated. If `null`, no existing push destinations are updated.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### setCandidateQueries

          public void setCandidateQueries(com.tibco.bpm.de.api.orgmodel.SetCandidateQueriesDocument.SetCandidateQueries.Remove aRemovals,
                                          com.tibco.bpm.de.api.base.XmlCandidateQueryAssignment[] aAssignments)
                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                          com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Sets, or updates, the Candidate Query assignments to identified org-model entities. Each org-model entity may only hold one Candidate Query. Any existing assignment will be ovewritten by a new assignment. Candidate Queries span all org-model versions in which the identified org-model entity exists. Therefore, the request does not include a model version.
      Specified by:
        `setCandidateQueries` in interface `OrgModelService`
      Parameters:
        `aRemovals` - identifies the entities from which any existing Candidate Queries are to be removed.
        `aAssignments` - identifies the entity which Candidate Queries are to be set.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### setExtensionPoints

          public void setExtensionPoints(com.tibco.bpm.de.api.base.XmlExtensionPointAssignment[] aSettings)
                                  throws com.tibco.n2.de.services.DirectoryEngineFault,
                                         com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Sets, or updates, the configurations for the identified Organisation Model Extension Point entities. Configurations apply to only the model version specified in the request elements.

      Any existing configuration for the identified entities will be overwritten. Attempting to set the configuration for an org-model entity to which the caller does not have access, will cause a SecurityFault.

      Changing an existing Extension Point configuration may invalidate any Model Template Instances that have previously been generated using the previous configuration; causing those invalud Model Template Instances to be deleted.

      Specified by:
        `setExtensionPoints` in interface `OrgModelService`
      Parameters:
        `aSettings` - the collection of configurations to be applied.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### setExtensionPoints

          public void setExtensionPoints(com.tibco.bpm.de.api.base.XmlExtensionPointRemoval[] aSettings)
                                  throws com.tibco.n2.de.services.DirectoryEngineFault,
                                         com.tibco.n2.de.services.SecurityFault

      Specified by:
        `setExtensionPoints` in interface `OrgModelService`
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### processDynamicOrg

          public void processDynamicOrg()
                                 throws com.tibco.n2.de.services.DirectoryEngineFault,
                                        com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Requests that the processing of the Extension Points and Candidate Queries be performed as soon as possible. The request is placed on a queue for immediate processing by the lead node. The request will not be processed by the thread on which the request was received, and this service will return immediately.
      Specified by:
        `processDynamicOrg` in interface `OrgModelService`
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getPushDestinations

          public com.tibco.bpm.de.api.orgmodel.XmlPushDestinationList[] getPushDestinations(com.tibco.n2.common.organisation.api.XmlModelEntityId[] parameterValues)
                                                                                     throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                            com.tibco.n2.de.services.SecurityFault

      Description copied from interface: `OrgModelService`
      Retrieve the Push Destinations for the identified org-model entities (or resource).
      Specified by:
        `getPushDestinations` in interface `OrgModelService`
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

Copyright © 2018 TIBCO Software Inc. All Rights Reserved.